!
!-----------------------------------------------------------------------
      program dustemissionflux
!-----------------------------------------------------------------------
!
      integer :: ncl,k,t,m,topsoiltype,step,exnr,xy
      character(1) :: topsoilchar1
      character(2) :: topsoilchar2
      real :: dum,dv
      integer,parameter :: nclass=20000,nsoil=4,scount=13
      real,parameter :: dstep=0.001,dvmin=0.0,dvmax=10.0
      real,dimension(1:nclass) :: hflux_tot,vflux_tot
      real,dimension(1:nclass) :: ustar
      real,dimension(1:nclass,1:nsoil) :: hflux_soil,vflux_soil
      character(140) :: outfile
      character(3),dimension(1:scount) :: statout
      character(7),dimension(1:2) :: z0select
!
      character*64 :: path='/ouce-home/staff/cenv0270/boxmodel/academic_&
     &OW64_calc_GSMC_2011/'
!
      data outfile /'                                                   &
     &                          '/
      data statout /'I04','B03','J11','D10','D02','D05','G02','J03',    &
     &              'I08','L05','G06','B07','all'/
      data z0select /'z0delta','z0origl'/
!
!-----------------------------------------------------------------------
!***********************************************************************
!-----------------------------------------------------------------------
!
      write(*,*) ' '
      write(*,*) 'WELCOME'
!
!-----------------------------------------------------------------------
!     MAKING FULL RESOLUTION USTAR TABLE
!-----------------------------------------------------------------------
!
      dv=dvmin
      do k=1,nclass
         dv=dv+dstep
         ustar(k)=dv
         if(dv.ge.dvmax)goto 301
      enddo
301   continue
!
      ncl=k-1
!
!-----------------------------------------------------------------------
!     BEGIN LOOP XY (ROUGHNESS 1 AND 2)
!-----------------------------------------------------------------------
!
      do xy=1,1
!
!-----------------------------------------------------------------------
!     BEGIN LOOP TEST CASES
!-----------------------------------------------------------------------
!
      DO exnr=1,8
!
!-----------------------------------------------------------------------
!     BEGIN LOOP OVER STATIONS
!-----------------------------------------------------------------------
!
      DO step=1,scount
!
!-----------------------------------------------------------------------
!     INCLUDE LOOP OVER TOPSOILCLASSES HERE
!-----------------------------------------------------------------------
!
      topsoiltype=step
      if(step.lt.10) then
        write(topsoilchar1,317) topsoiltype
        write(*,318) topsoilchar1
317     format(I1)
318     format(A1)
      else
        write(topsoilchar2,325) topsoiltype
        write(*,326) topsoilchar2
325     format(I2)
326     format(A2)
      endif
!
!-----------------------------------------------------------------------
!
      write(*,*) ' '
      write(*,*) 'START SUBROUTINE ...'
!
!-----------------------------------------------------------------------
!     RUN PREFERED EMISSION SCHEME
!-----------------------------------------------------------------------
!
      call owen(ncl,ustar,hflux_soil,vflux_soil,hflux_tot               &
     &         ,vflux_tot,topsoiltype,step,exnr,xy)
!
!-----------------------------------------------------------------------
!
      write(*,*) 'SUBROUTINE COMPLETED'
!
!-----------------------------------------------------------------------
!     WRITING OUTPUT DATA
!-----------------------------------------------------------------------
!
      if(step.lt.10) then
      select case (exnr)
      case(1)
      outfile=path//'dustemission_OW64_S0'//topsoilchar1//'_acad_4b_orig&
     &nl_'//statout(step)//'_'//z0select(xy)//'_dansie.txt'
      case(2)
      outfile=path//'dustemission_OW64_S0'//topsoilchar1//'_acad_4b_noMo&
     &is_usthrC_'//statout(step)//'_'//z0select(xy)//'_dansie.txt'
      case(3)
      outfile=path//'dustemission_OW64_S0'//topsoilchar1//'_acad_4b_noMo&
     &is_'//statout(step)//'_'//z0select(xy)//'_dansie.txt'
      case(4)
      outfile=path//'dustemission_OW64_S0'//topsoilchar1//'_acad_4b_noCo&
     &rr_dansie.txt'
      case(5)
      outfile=path//'dustemission_OW64_S0'//topsoilchar1//'_acad_4b_noCo&
     &rr_usthrC_dansie.txt'
      case(6)
      outfile=path//'dustemission_OW64_S0'//topsoilchar1//'_acad_4b_usth&
     &rC_'//statout(step)//'_'//z0select(xy)//'_dansie.txt'
      case(7)
      outfile=path//'dustemission_OW64_S0'//topsoilchar1//'_acad_4b_noDr&
     &ag_usthrC_dansie.txt'
      case(8)
      outfile=path//'dustemission_OW64_S0'//topsoilchar1//'_acad_4b_noDr&
     &ag_dansie.txt'
      end select
      else
      select case (exnr)
      case(1)
      outfile=path//'dustemission_OW64_S'//topsoilchar2//'_acad_4b_orign&
     &l_'//statout(step)//'_'//z0select(xy)//'_dansie.txt'
      case(2)
      outfile=path//'dustemission_OW64_S'//topsoilchar2//'_acad_4b_noMoi&
     &s_usthrC_'//statout(step)//'_'//z0select(xy)//'_dansie.txt'
      case(3)
      outfile=path//'dustemission_OW64_S'//topsoilchar2//'_acad_4b_noMoi&
     &s_'//statout(step)//'_'//z0select(xy)//'_dansie.txt'
      case(4)
      outfile=path//'dustemission_OW64_S'//topsoilchar2//'_acad_4b_noCor&
     &r_dansie.txt'
      case(5)
      outfile=path//'dustemission_OW64_S'//topsoilchar2//'_acad_4b_noCor&
     &r_usthrC_dansie.txt'
      case(6)
      outfile=path//'dustemission_OW64_S'//topsoilchar2//'_acad_4b_usthr&
     &C_'//statout(step)//'_'//z0select(xy)//'_dansie.txt'
      case(7)
      outfile=path//'dustemission_OW64_S'//topsoilchar2//'_acad_4b_noDra&
     &g_usthrC_dansie.txt'
      case(8)
      outfile=path//'dustemission_OW64_S'//topsoilchar2//'_acad_4b_noDra&
     &g_dansie.txt'
      end select
      endif
!
      open(unit=20,file=outfile)
      write(20,*) ' ustar  hflux_OW 1  hflux_OW 2  hflux_OW 3  hflux_OW &
     &4  vflux_OW 1  vflux_OW 2  vflux_OW 3  vflux_OW 4   hflux_tot   vf&
     &lux_tot'
      write(20,*) ' (m/s)   (kg/m/s)   (mg/m2/s)   site: ',statout(step)
      write(20,*) '-----------------------------------------------------&
     &------------------------------------------------------------------&
     &-------'
!
      do t=1,ncl
         write(20,134) ustar(t),hflux_soil(t,1),hflux_soil(t,2)         &
     &                ,hflux_soil(t,3),hflux_soil(t,4),vflux_soil(t,1)  &
     &                ,vflux_soil(t,2),vflux_soil(t,3),vflux_soil(t,4)  &
     &                ,hflux_tot(t),vflux_tot(t)
      enddo
      close(20)
134   format(1X,F6.3,4(3X,F9.5),4(3X,F9.3),3X,F9.5,3X,F10.3)
!
!-----------------------------------------------------------------------
!     END LOOP OVER STATIONS
!-----------------------------------------------------------------------
!
      enddo
!
!-----------------------------------------------------------------------
!     END LOOP TEST CASES
!-----------------------------------------------------------------------
!
      enddo
!
!-----------------------------------------------------------------------
!     END LOOP XY
!-----------------------------------------------------------------------
!
      enddo
!
!-----------------------------------------------------------------------
!
      write(*,*) ' '
      write(*,*) 'YOU ARE DONE!'
!
!-----------------------------------------------------------------------
      end
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
!#######################################################################
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
      subroutine owen(ncl,ustar,hflux_soil,vflux_soil,hflux_tot         &
                     ,vflux_tot,topsoiltype,step,exnr,xy)
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
!     White [1979] horizontal and Marticorena and Bergametti [1995]
!     vertical dust mass flux scheme
!-----------------------------------------------------------------------
!
      integer :: nsource,soiltypes
      parameter (nsource=3,soiltypes=16)
      parameter (nsoil=4,nclass=20000)
      real,parameter :: g=9.81,air_dens=1.227         ! kg/m3
!
      integer, dimension(8) :: usthrc = (/ 0,1,0,0,1,1,1,0 /)
      integer, dimension(8) :: nomois = (/ 0,1,1,1,1,0,0,0 /)
      integer, dimension(8) :: nodrag = (/ 0,0,0,1,1,0,1,1 /)
!
!-----------------------------------------------------------------------
!     INPUT PARAMETER
!-----------------------------------------------------------------------
!
      integer,intent(in) :: ncl,topsoiltype,step,exnr,xy
      real,dimension(1:nclass),intent(in) :: ustar
      real,dimension(1:ncl),intent(out) :: hflux_tot,vflux_tot
      real,dimension(1:nclass,1:nsoil),intent(out) :: hflux_soil        &
     &                                               ,vflux_soil
      real,parameter :: viscos=1.718e-5                 ! dynamic viscosity of air (kg/m/s)
!
!-----------------------------------------------------------------------
!
      real :: soil_sa_tot,z0s,drag_corr,alpha,wprim,vsmc_sat,rho_bulk
      real :: z0temp,alpha_temp,RTEMP,vsmc,gsmc,gsmc_frac
      real,dimension(1:nsoil) :: hflux,rel_sfc,alpha_soil
      real,dimension(1:nsoil) :: ustarthr,ustardry,reynthr
      real,dimension(1:nsoil) :: soil_diam,soil_dens,soil_sigma
      real,dimension(1:nsoil) :: soil_sa,soil_mf,soil_mf_wet,ws
      real,dimension(1:nsource) :: source_diam,source_sigma,source_mf
      real,dimension(1:13) :: z0avg1,z0avg2,vsmcavg1,vsmcavg2
      real,dimension(1:13) :: obs_bcly,obs_bslt,obs_mfsnd,obs_csnd
      real,dimension(1:13) :: wet_bcly,wet_bslt,wet_mfsnd,wet_csnd
!
!-----------------------------------------------------------------------
!     4 SOIL SIZE CATEGORIES
!-----------------------------------------------------------------------
!
      data soil_diam /2.E-6,15.E-6,160.E-6,710.E-6/   ! soil grains mean diameter (m)
      data soil_dens /2500.,2650.,2650.,2650./        ! soil grains density (kg/m3)
      data soil_sigma /1.8,1.8,1.7,1.6/               ! soil populations geom. standard deviation
      data alpha_soil /1.E-4,1.E-3,1.E-4,1.E-5/       ! 1/m (clay, silt, f/m sand, c sand)
!
!-----------------------------------------------------------------------
!     TRI-MODAL SIZE DISTRIBUTION IN SOURCE REGIONS (D'ALMEIDA 1987)
!-----------------------------------------------------------------------
!
      data source_diam /0.832,4.82,19.38/             ! mass mean diameter (microns)
      data source_sigma /2.10,1.9,1.6/                ! geometric standard deviation
      data source_mf /0.036,0.957,0.007/              ! mass fraction
!
!----------------------------------------------------------------------
!     DRY SOIL SIZE DISTRIBUTION FOR EACH SITE USING SIEVED SAMPLES
!     NO FLUFF INFORMATION AVAILABLE FOR J11, L05 (CRUST INSTEAD) AND
!     D02 (UCT DRY INSTEAD). MALVERN ANALYSIS CARRIED OUT BY ANDREW
!     DANSIE AT OUCE. IT IS THE FINAL ANALYSIS (ALSO USED FOR 2012).
!----------------------------------------------------------------------
!
      data obs_bcly  /0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00           &
     &               ,0.00,0.00,0.00,0.00,0.00/
      data obs_bslt  /0.21,0.22,0.14,0.04,0.01,0.13,0.21,0.19           &
     &               ,0.06,0.05,0.15,0.09,0.13/
      data obs_mfsnd /0.73,0.53,0.48,0.32,0.74,0.51,0.67,0.70           &
     &               ,0.46,0.21,0.56,0.37,0.52/
      data obs_csnd  /0.06,0.25,0.34,0.64,0.25,0.36,0.12,0.11           &
     &               ,0.48,0.74,0.29,0.54,0.35/
!
!----------------------------------------------------------------------
!     WET SOIL SIZE DISTRIBUTION FOR EACH SITE USING THE ENTIRE SAMPLE
!     THE ANALYSIS DISSECTS GRAINS INTO ITS SMALLEST COMPONENTS. NO
!     FLUFF INFORMATION AVAILABLE FOR J11 AND L05 (CRUST INSTEAD).
!     MALVERN ANALYSIS CARRIED OUT BY ANDREW DANSIE AT OUCE.
!----------------------------------------------------------------------
!
      data wet_bcly  /0.09,0.11,0.12,0.09,0.14,0.10,0.07,0.09           &
     &               ,0.11,0.09,0.11,0.10,0.10/
      data wet_bslt  /0.61,0.63,0.68,0.74,0.74,0.68,0.60,0.51           &
     &               ,0.80,0.64,0.77,0.73,0.68/
      data wet_mfsnd /0.29,0.26,0.19,0.16,0.12,0.22,0.33,0.40           &
     &               ,0.09,0.27,0.11,0.17,0.22/
      data wet_csnd  /0.01,0.00,0.01,0.01,0.00,0.00,0.00,0.00           &
     &               ,0.00,0.00,0.01,0.00,0.00/
!
!----------------------------------------------------------------------
!     ROUGHNESS AND VOLUMETRIC SOIL MOISTURE FOR DIFFERENT FIELD SITES
!----------------------------------------------------------------------
!
      data z0avg1 /0.00230,0.00236,0.00108,0.00292,0.00000,0.00291      &
     &            ,0.00293,0.00047,0.00000,0.00006,0.00391,0.00200      &
     &            ,0.00175/          ! delta (avg. z0 if vflux>0 = delta)
      data z0avg2 /0.00241,0.00219,0.00074,0.00326,0.00202,0.00245      &
     &            ,0.00226,0.00085,0.00112,0.00005,0.00283,0.00139      &
     &            ,0.00180/          ! origl (average for all z0 = origl)
!
      data vsmcavg1 /0.07195,0.06034,0.16590,0.04039,0.00000,0.14703    &
     &              ,0.07726,0.15482,0.00000,0.16787,0.11342,0.15095    &
     &              ,0.09583/        ! delta (avg. vsmc if vflux>0 = delta)
      data vsmcavg2 /0.09745,0.05531,0.16649,0.06479,0.07131,0.14981    &
     &              ,0.07668,0.15546,0.13614,0.16695,0.12714,0.15097    &
     &              ,0.11821/        ! origl (average for all z0 = origl)
!
!-----------------------------------------------------------------------
!***********************************************************************
!-----------------------------------------------------------------------
!
!      write(*,*) topsoiltype
!
!-----------------------------------------------------------------------
!     THRESHOLD FRICTION VELOCITY AFTER IVERSEN AND WHITE 1982
!-----------------------------------------------------------------------
!
      do k=1,nsoil
        reynthr(k)= 0.38+1331.*(100.*soil_diam(k))**1.56
        if(reynthr(k).le.10.)then
          ustardry(k)=(1.+(6.E-7)/(soil_dens(k)*9.81*soil_diam(k)**2.5))&
     &    **0.5*0.1291*(1.928*reynthr(k)**0.0922-1.)**(-0.5)            &
     &    *sqrt(soil_dens(k)*9.81*soil_diam(k)/air_dens)
        elseif(reynthr(k).gt.10.)then
          ustardry(k)=(1.+(6.E-7)/(soil_dens(k)*9.81*soil_diam(k)**2.5))&
     &    **0.5*0.120*(1.-0.0858*exp(-0.0617*(reynthr(k)-10.)))         &
     &    *sqrt(soil_dens(k)*9.81*soil_diam(k)/air_dens)
        endif
      enddo
!
!----------------------------------------------------------------------
!     RELATIVE SURFACE AREA OF EACH SOIL GRAIN BIN
!----------------------------------------------------------------------
!
      soil_mf(1)=obs_bcly(topsoiltype)
      soil_mf(2)=obs_bslt(topsoiltype)
      soil_mf(3)=obs_mfsnd(topsoiltype)
      soil_mf(4)=obs_csnd(topsoiltype)
!
      soil_mf_wet(1)=wet_bcly(topsoiltype)
      soil_mf_wet(2)=wet_bslt(topsoiltype)
      soil_mf_wet(3)=wet_mfsnd(topsoiltype)
      soil_mf_wet(4)=wet_csnd(topsoiltype)
!
      wprim=0.0014*(soil_mf_wet(1)*100.)**2+(0.17*(soil_mf_wet(1)*100.))
!
!----------------------------------------------------------------------
!
      do k=1,nsoil
        soil_sa(k)=3.*soil_mf(k)/(2.*soil_dens(k)*soil_diam(k))
      enddo
      soil_sa_tot=soil_sa(1)+soil_sa(2)+soil_sa(3)+soil_sa(4)
!
      if(soil_sa_tot.gt.0.)then
        do k=1,nsoil
          soil_sa(k)=soil_sa(k)/soil_sa_tot
        enddo
      else
        do k=1,nsoil
          soil_sa(k)=0.
        enddo
      endif
!
!----------------------------------------------------------------------
!    GRAIN SIZE TERMINAL VELOCITY AFTER SHAO 2008 (P.130)
!----------------------------------------------------------------------
!
      do k=1,nsoil
        reynthr(k)= 0.38+1331.*(100.*soil_diam(k))**1.56
        if(reynthr(k).lt.1000.)then
          ws(k)=soil_dens(k)*9.81*soil_diam(k)**2/(18*viscos)
        elseif(reynthr(k).ge.1000.)then
          ws(k)=1.66*(soil_dens(k)*9.81*soil_diam(k))**0.5
        endif
      enddo
!
!----------------------------------------------------------------------
!    VERTICAL TO HORIZONTAL DUST MASS FLUX RATIO ALPHA
!----------------------------------------------------------------------
!
      write(*,*) ' '
      alpha=0.
      alpha_temp=0.
      do k=1,nsoil
        alpha_temp=alpha_soil(k)
        if (k==1.and.soil_mf_wet(1).gt.0.45) alpha_temp=1.e-5
        alpha=alpha+alpha_temp*soil_mf_wet(k)
      enddo
      write(*,*) 'alpha:',alpha
!
!-----------------------------------------------------------------------
!     VOLUMETRIC TO GRAVIMETRIC SOIL MOISTURE AFTER ZENDER ET AL 2003
!-----------------------------------------------------------------------
!
      vsmc_sat=0.489-1.26*(soil_mf(3)+soil_mf(4))      ! Volumetric soil water content at saturation (Zender et al. 2003)
      rho_bulk=2500.*(1.-vsmc_sat)                     ! bulk density of dry soil
!
!-----------------------------------------------------------------------
!     DUST EMISSION FLUX PARAMETERIZATION STARTS HERE
!     FIRST RESET THE ARRAYS
!-----------------------------------------------------------------------
!
      do t=1,ncl
        hflux_tot(t)=0.
        vflux_tot(t)=0.
        do k=1,nsoil
          hflux_soil(t,k)=0.
          vflux_soil(t,k)=0.
        enddo
      enddo
!
!-----------------------------------------------------------------------

      do t=1,ncl
!
!-----------------------------------------------------------------------
!
        z0s=0.
        z0temp=0.
        drag_corr=0.
        do k=1,nsoil
          hflux(k)=0.
        enddo

!-----------------------------------------------------------------------
!     DRAG PARTITION CORRECTION AFTER MARTICORENA/BERGAMETTI 1995
!     Z0S/Z0DUST smooth (constant) and aeolian (meteo) roughness length
!-----------------------------------------------------------------------
!
        if(soil_sa(4).eq.0.) then
          z0s=1./30.*soil_diam(3)
        else
          z0s=1./30.*soil_diam(4)
        endif
!
        if(xy.eq.1) z0temp=1.0*z0avg1(step)
        if(xy.eq.2) z0temp=1.0*z0avg2(step)
!
        if(z0temp.ge.z0s) then
          drag_corr=1.-(log(z0temp/z0s)/log(0.7*(122.55/z0s)**0.8))   !<-- MacKinnon, 2004
        else
          drag_corr=1.
        endif
        if(drag_corr.lt.0.2) drag_corr=0.2
!
!-----------------------------------------------------------------------
!
        if(xy.eq.1) vsmc=1.0*vsmcavg1(step)
        if(xy.eq.2) vsmc=1.0*vsmcavg2(step)
!
!-----------------------------------------------------------------------
!
        do k=1,nsoil
!
!-----------------------------------------------------------------------
!     SOIL MOISTURE CORRECTION AFTER FECAN 1999
!-----------------------------------------------------------------------
!          
          if(usthrc(exnr).eq.1) ustardry(k)=0.5
!
          if(nomois(exnr).eq.1) then
            ustarthr(k)=ustardry(k)
          else
            if(vsmc.eq.1.) gsmc=1.
            if(vsmc.lt.1.) gsmc=vsmc*1000./rho_bulk               ! Gravimetric SMC in kg/kg and volumetric in m3/m3
            gsmc_frac=gsmc*100.
            if(gsmc_frac.gt.wprim.and.gsmc_frac.lt.100.) then
              ustarthr(k)=ustardry(k)*sqrt(1.+1.21                      &
     &                   *(gsmc_frac-wprim)**0.68)
            else
              ustarthr(k)=ustardry(k)
            endif
          endif
!
          if(nodrag(exnr).eq.1) then
            ustarthr(k)=ustarthr(k)
          else
            ustarthr(k)=ustarthr(k)/drag_corr
          endif
!
!-----------------------------------------------------------------------
!     HORIZONTAL FLUX AFTER OWEN 1964
!-----------------------------------------------------------------------
!
          if(ustar(t).ge.ustarthr(k)) then
            hflux(k)=1.0*(air_dens/9.81)*(ustar(t)**3)                  &
     &              *(1-(ustarthr(k)/ustar(t))**2)                      &
     &              *(0.25+0.33*(ws(k)/ustar(t)))*soil_sa(k)
          endif
          hflux_tot(t)=hflux_tot(t)+hflux(k)
          hflux_soil(t,k)=hflux(k)
!
!-----------------------------------------------------------------------
!
        enddo
!
!-----------------------------------------------------------------------
!     VERTICAL FLUX AFTER MARTICORENA AND BERGAMETTI 1995
!     CONVERSION FROM kg/m3 TO mg/m3
!-----------------------------------------------------------------------
!
        do k=1,nsoil
          vflux_soil(t,k)=alpha*hflux_soil(t,k)*1.E6
        enddo
        vflux_tot(t)=alpha*hflux_tot(t)*1.E6
!
!-----------------------------------------------------------------------
!
      enddo
!
!-----------------------------------------------------------------------
      end subroutine owen
!-----------------------------------------------------------------------
!
