!
!-----------------------------------------------------------------------
      program dustemissionflux
!-----------------------------------------------------------------------
!
      integer :: time,temp_time,day,temp_day,idoy,t,d                   &
     &          ,sstep,npts,npt1,npt2,npt3,npt4
      real :: dum,conc_tmp,conc_sum,conc_ssq,conc_std                   &
     &       ,z0sum1,z0sum2,z0avg1,z0avg2,VSMCsum1,VSMCsum2             &
     &       ,VSMCavg1,VSMCavg2,hsum_obs,vsum_obs,hsum_mod,vsum_mod
      parameter (scount=12)
      parameter (time=100000)
      parameter (day=200)
      integer,dimension(1:time) :: sens_obs
      integer,dimension(1:day) :: jday
      real,dimension(1:time) :: doy,ustar,z0dust,conc_obs,senstemp      &
     &                         ,hflux_tot,vflux_tot,hflux_obs,vflux_obs &
     &                         ,vsmc_temp
      real,dimension(1:scount,1:day) :: vsmc
      real,dimension(1:scount,1:time) :: vsmc_full,vsmc_obs
      character(140) :: infile1,infile2,outfile
      character(8),dimension(1:scount) :: statin
      character(3),dimension(1:scount) :: statout
      character*50 :: path='/ouce-home/staff/cenv0270/boxmodel/GSMC_SH04&
     &_2011/'
!
      data statin /'METg_I04','METa_B03','METb_D10','METc_J11',         &
     &             'METd_D02','METe_D05','METf_G02','METg_J03',         &
     &             'METh_I08','AWS1_L05','AWS2_G06','AWS3_B07'/
      data statout /'I04','B03','D10','J11','D02','D05','G02','J03',    &
     &              'I08','L05','G06','B07'/
!
!-----------------------------------------------------------------------
!***********************************************************************
!-----------------------------------------------------------------------
!
      write(*,*) ' '
      write(*,*) 'WELCOME'
!
!-----------------------------------------------------------------------
!     READING DAILY MOISTURE DATA FIRST
!-----------------------------------------------------------------------
!
      temp_day=0
      infile2='VSMC_QC_daily.csv'
      open(unit=20,file=infile2)
      do d=1,day
        read(20,*,end=118) dum
        temp_day=temp_day+1
      enddo
118   continue
      close(20)
!
      open(unit=20,file=infile2)
      do d=1,temp_day
        read(20,*) jday(d),vsmc(10,d),vsmc(11,d),vsmc(12,d),vsmc(2,d)   &
     &            ,vsmc(3,d),vsmc(4,d),vsmc(5,d),vsmc(6,d),vsmc(7,d)    &
     &            ,vsmc(1,d),vsmc(8,d),vsmc(9,d)
      enddo
      close(20)
!
!-----------------------------------------------------------------------
!     LOOP OVER STATIONS
!-----------------------------------------------------------------------
!
      DO sstep=1,scount
!
!-----------------------------------------------------------------------
!     READING OTHER INPUT DATA
!-----------------------------------------------------------------------
!
      temp_time=0
      infile1=statin(sstep)//'_day3Zoten_NEW.csv'
      open(unit=10,file=infile1)
      do t=1,time
        read(10,*,end=101) dum
        temp_time=temp_time+1
      enddo
101   continue
      close(10)
!
      open(unit=10,file=infile1)
      do t=1,temp_time
        read(10,*) doy(t),dum,dum,dum,dum,dum,dum,dum,senstemp(t),dum   &
     &            ,z0dust(t),ustar(t),dum,dum,dum,dum,dum,dum,dum       &
     &            ,conc_obs(t),vflux_obs(t),hflux_obs(t)
      enddo
      close(10)
!
!-----------------------------------------------------------------------
!     CONVERT DAILY TO FULLY TEMPORALLY RESOLVED VSMC
!-----------------------------------------------------------------------
!
      do t=1,temp_time
        idoy=INT(doy(t))
        do d=1,temp_day
          if (idoy.eq.jday(d)) vsmc_full(sstep,t)=REAL(vsmc(sstep,d))
        enddo
        if(isnan(vsmc_full(sstep,t)).eq.0) vsmc_obs(sstep,t)=           &
     &                                     vsmc_full(sstep,t)
      enddo
!
      do t=1,temp_time
        if (vsmc_obs(sstep,t).eq.0.0) vsmc_obs(sstep,t) = 1.0
      enddo
!
      do t=1,temp_time
        vsmc_temp(t) = vsmc_obs(sstep,t)
      enddo
!
!-----------------------------------------------------------------------
!
      write(*,*) ' '
      write(*,*) 'START SUBROUTINE ...'
!
!-----------------------------------------------------------------------
!     RUN PREFERED EMISSION SCHEME
!-----------------------------------------------------------------------
!
      call shao(time,temp_time,ustar,z0dust,scount,sstep                &
     &         ,hflux_tot,vflux_tot,vsmc_temp)
!
!-----------------------------------------------------------------------
!
      write(*,*) 'SUBROUTINE COMPLETED'
!
!-----------------------------------------------------------------------
!
      do t=1,temp_time
        if(isnan(senstemp(t)).eq.1) sens_obs(t)='NAN'
        if(isnan(senstemp(t)).eq.0) sens_obs(t)=senstemp(t)
      enddo
!
!-----------------------------------------------------------------------
!
      npts=0
      conc_sum=0.0
      conc_std=0.0
      do t=1,temp_time
        if(isnan(conc_obs(t)).eq.0) then
          conc_sum=conc_sum+conc_obs(t)
          npts=npts+1
        endif
      enddo
      conc_sum=conc_sum/npts
      do t=1,temp_time
        if(isnan(conc_obs(t)).eq.0) then
          conc_ssq=conc_ssq+(conc_obs(t)-conc_sum)**2
        endif
      enddo
      conc_std=sqrt(conc_ssq/npts)
!
      conc_tmp=0.0
      do t=2,temp_time
        if(isnan(vflux_obs(t)).eq.0) then
          conc_tmp=conc_obs(t)-conc_obs(t-1)
          if(conc_tmp.lt.conc_std) vflux_obs(t)=0.0
        endif
      enddo
!
      do t=1,temp_time
        hflux_obs(t)=hflux_obs(t)*1.0
        vflux_obs(t)=vflux_obs(t)*1.0
      enddo
!
!-----------------------------------------------------------------------
!     AVERAGE ROUGHNESS LENGTH AND GRAVITATIONAL SOIL MOISTURE CONTENT
!-----------------------------------------------------------------------
!
      npt1=0
      npt2=0
      npt3=0
      npt4=0
      z0sum1=0.0
      z0sum2=0.0
      z0avg1=0.0
      z0avg2=0.0
      VSMCsum1=0.0
      VSMCsum2=0.0
      VSMCavg1=0.0
      VSMCavg2=0.0
      do t=1,temp_time
        if(isnan(z0dust(t)).eq.0) then
          z0sum1=z0sum1+z0dust(t)
          npt1=npt1+1
          if(vflux_obs(t).gt.0.0) then
            z0sum2=z0sum2+z0dust(t)
            npt2=npt2+1
          endif
        endif
      enddo
      z0avg1=REAL(z0sum1/npt1)
      z0avg2=REAL(z0sum2/npt2)
      do t=1,temp_time
        if(vsmc_obs(sstep,t).lt.1.0) then
          VSMCsum1=VSMCsum1+vsmc_obs(sstep,t)
          npt3=npt3+1
          if(vflux_obs(t).gt.0.0) then
            VSMCsum2=VSMCsum2+vsmc_obs(sstep,t)
            npt4=npt4+1
          endif
        endif
      enddo
      VSMCavg1=REAL(VSMCsum1/npt3)
      VSMCavg2=REAL(VSMCsum2/npt4)
!
!-----------------------------------------------------------------------
!
      hsum_obs=0
      vsum_obs=0
      hsum_mod=0
      vsum_mod=0
      hsum_obs=SUM(hflux_obs*1E3,t,mask = isnan(vflux_obs).eq.0)
      vsum_obs=SUM(vflux_obs    ,t,mask = isnan(vflux_obs).eq.0)
      hsum_mod=SUM(hflux_tot*1E6,t,mask = isnan(vflux_obs).eq.0)
      vsum_mod=SUM(vflux_tot    ,t,mask = isnan(vflux_obs).eq.0)
!
!-----------------------------------------------------------------------
!     WRITING OUTPUT DATA
!-----------------------------------------------------------------------
!
      outfile=path//'dustemission_'//statout(sstep)//'_SH04_day3_delta_2&
     &011_dansie.txt'
!
263   format(I1)
271   format(I2)
288   format(A1)
296   format(A2)
!
      open(unit=20,file=outfile)
      write(20,*) '-----------------------------------------------------&
     &-------------------------'
      write(20,*) '  time    ustar  hflux_OBS  hflux_SH04  vflux_OBS  vf&
     &lux_SH04  z0dust   VSMC  '
      write(20,*) '  (doy)   (m/s)   (mg/m/s)   (mg/m/s)   (mg/m2/s)  (m&
     &g/m2/s)   (m/s)   m3/m3  '
      write(20,*) '-----------------------------------------------------&
     &-------------------------'
      write(20,125) '  average all z0  :',z0avg1,  ' average vflux>0 z0 &
     & :' ,z0avg2
      write(20,125) '  average all VSMC:',VSMCavg1,' average vflux>0 VSM&
     &C:' ,VSMCavg2
      write(20,*) '-----------------------------------------------------&
     &-------------------------'
      write(20,133) '  sum fluxes: ',hsum_obs,hsum_mod,vsum_obs,vsum_mod
      write(20,*) '-----------------------------------------------------&
     &-------------------------'
!
      do t=1,temp_time
        if(isnan(vflux_obs(t)).eq.0) then
            write(20,134) doy(t),ustar(t),hflux_obs(t)*1E3              &
     &                   ,hflux_tot(t)*1E6,vflux_obs(t),vflux_tot(t)    &
     &                   ,z0dust(t),vsmc_obs(sstep,t)
        else
          continue
        endif
      enddo
      close(20)
125   format(1X,A19,1X,F8.5,8X,A22,1X,F8.5)
126   format(2X,F7.3,4X,A5,3X,I4,2X,F9.6,3(2X,F9.5),5X,F6.3)
133   format(1X,A14,4X,F8.2,2X,F8.1,2X,F9.4,2X,F9.3)
134   format(2X,F7.3,2X,F6.3,2X,F8.3,2X,F8.1,2(2X,F9.5),3X,F7.4,3X,F6.3)
!
!-----------------------------------------------------------------------
!     END STATION LOOP
!-----------------------------------------------------------------------
!
      ENDDO
!
!-----------------------------------------------------------------------
!
      write(*,*) ' '
      write(*,*) 'YOU ARE DONE!'
!
!-----------------------------------------------------------------------
      end
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
!#######################################################################
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
      subroutine shao(time,temp_time,ustar,z0dust,scount,sstep          &
     &               ,hflux_tot,vflux_tot,vsmc_temp)
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
!     White [1979] horizontal and Marticorena and Bergametti [1995]
!     vertical dust mass flux scheme
!-----------------------------------------------------------------------
!
      integer :: nsoil,nsource,scountt,t,k,topsoiltype
      parameter (nsoil=4,nsource=3,scountt=12)
      real,parameter :: g=9.81,air_dens=1.227         ! kg/m3
      real,parameter :: ggamm=1.65E-4,an=0.0123,ustp=5.0
!
!-----------------------------------------------------------------------
!     INPUT PARAMETER
!-----------------------------------------------------------------------
!
      integer,intent(in) :: time,temp_time,sstep,scount
      real,dimension(1:time),intent(in) :: ustar,z0dust,vsmc_temp
      real,dimension(1:time),intent(out) :: hflux_tot,vflux_tot
!
!-----------------------------------------------------------------------
!
      real :: soil_sa_tot,drag_corr,wprim,gamm,sigmm,vsmc_tune          &
     &       ,z0temp,av,lambdav,lambdab,soil_sa_wet_tot                 &
     &       ,gsmc,gsmc_frac,vsmc,vsmc_sat,rho_bulk
      real,dimension(1:scountt) :: obs_bcly,obs_bslt,obs_mfsnd,obs_csnd &
     &                            ,wet_bcly,wet_bslt,wet_mfsnd,wet_csnd
      real,dimension(1:nsoil) :: hflux,rel_sfc,alpha_soil,soil_sa_ratio &
     &                          ,ustarthr,ustardry,reynthr,soil_mf_ratio&
     &                          ,soil_diam,soil_dens,soil_sigma         &
     &                          ,soil_sa,soil_sa_wet,soil_mf,soil_mf_wet
      real,dimension(1:nsource) :: source_diam,source_sigma,source_mf
      real,dimension(1:time,1:nsoil) :: hflux_soil,vflux_soil
!
!-----------------------------------------------------------------------
!     4 SOIL SIZE CATEGORIES
!-----------------------------------------------------------------------
!
      data soil_diam /2.E-6,15.E-6,160.E-6,710.E-6/   ! soil grains mean diameter (m)
      data soil_dens /2500.,2650.,2650.,2650./        ! soil grains density (kg/m3)
      data soil_sigma /1.8,1.8,1.7,1.6/               ! soil populations geom. standard deviation
!
!-----------------------------------------------------------------------
!     TRI-MODAL SIZE DISTRIBUTION IN SOURCE REGIONS (D'ALMEIDA 1987)
!-----------------------------------------------------------------------
!
      data source_diam /0.832,4.82,19.38/             ! mass mean diameter (microns)
      data source_sigma /2.10,1.9,1.6/                ! geometric standard deviation
      data source_mf /0.036,0.957,0.007/              ! mass fraction
!
!----------------------------------------------------------------------
!     DRY SOIL SIZE DISTRIBUTION FOR EACH SITE USING SIEVED SAMPLES
!     NO FLUFF INFORMATION AVAILABLE FOR J11, L05 (CRUST INSTEAD) AND
!     D02 (UCT DRY INSTEAD). MALVERN ANALYSIS CARRIED OUT BY ANDREW
!     DANSIE AT OUCE. IT IS THE FINAL ANALYSIS (ALSO USED FOR 2012).
!----------------------------------------------------------------------
!
      data obs_bcly  /0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00           &
     &               ,0.00,0.00,0.00,0.00/
      data obs_bslt  /0.21,0.22,0.14,0.04,0.01,0.13,0.21,0.19           &
     &               ,0.06,0.05,0.15,0.09/
      data obs_mfsnd /0.73,0.53,0.48,0.32,0.74,0.51,0.67,0.70           &
     &               ,0.46,0.21,0.56,0.37/
      data obs_csnd  /0.06,0.25,0.34,0.64,0.25,0.36,0.12,0.11           &
     &               ,0.48,0.74,0.29,0.54/
!
!----------------------------------------------------------------------
!     WET SOIL SIZE DISTRIBUTION FOR EACH SITE USING THE ENTIRE SAMPLE
!     THE ANALYSIS DISSECTS GRAINS INTO ITS SMALLEST COMPONENTS. NO
!     FLUFF INFORMATION AVAILABLE FOR J11 AND L05 (CRUST INSTEAD).
!     MALVERN ANALYSIS CARRIED OUT BY ANDREW DANSIE AT OUCE.
!----------------------------------------------------------------------
!
      data wet_bcly  /0.09,0.11,0.12,0.09,0.14,0.10,0.07,0.09           &
     &               ,0.11,0.09,0.11,0.10/
      data wet_bslt  /0.61,0.63,0.68,0.74,0.74,0.68,0.60,0.51           &
     &               ,0.80,0.64,0.77,0.73/
      data wet_mfsnd /0.29,0.26,0.19,0.16,0.12,0.22,0.33,0.40           &
     &               ,0.09,0.27,0.11,0.17/
      data wet_csnd  /0.01,0.00,0.01,0.01,0.00,0.00,0.00,0.00           &
     &               ,0.00,0.00,0.01,0.00/
!
!-----------------------------------------------------------------------
!
      topsoiltype=sstep
!
!-----------------------------------------------------------------------
!     THRESHOLD FRICTION VELOCITY AFTER SHAO AND LU 2000
!-----------------------------------------------------------------------
!
      do k=1,nsoil
        ustardry(k)=sqrt(an*((soil_dens(k)*g*soil_diam(k)/air_dens)     &
     &             +(ggamm/air_dens/soil_diam(k))))
      enddo
!
!----------------------------------------------------------------------
!     RELATIVE SURFACE AREA OF EACH SOIL GRAIN BIN
!----------------------------------------------------------------------
!
      soil_mf(1)=obs_bcly(topsoiltype)
      soil_mf(2)=obs_bslt(topsoiltype)
      soil_mf(3)=obs_mfsnd(topsoiltype)
      soil_mf(4)=obs_csnd(topsoiltype)
!
      soil_mf_wet(1)=wet_bcly(topsoiltype)
      soil_mf_wet(2)=wet_bslt(topsoiltype)
      soil_mf_wet(3)=wet_mfsnd(topsoiltype)
      soil_mf_wet(4)=wet_csnd(topsoiltype)
!
      wprim=0.0014*(soil_mf_wet(1)*100.)**2+(0.17*(soil_mf_wet(1)*100.))
!
!----------------------------------------------------------------------
!
      do k=1,nsoil
        soil_sa(k)=3.*soil_mf(k)/(2.*soil_dens(k)*soil_diam(k))
        soil_sa_wet(k)=3.*soil_mf_wet(k)/(2.*soil_dens(k)*soil_diam(k))
      enddo
      soil_sa_tot=soil_sa(1)+soil_sa(2)+soil_sa(3)+soil_sa(4)
      soil_sa_wet_tot=soil_sa_wet(1)+soil_sa_wet(2)                     &
     &               +soil_sa_wet(3)+soil_sa_wet(4)
!
      if(soil_sa_tot.gt.0.)then
        do k=1,nsoil
          soil_sa(k)=soil_sa(k)/soil_sa_tot
        enddo
      else
        do k=1,nsoil
          soil_sa(k)=0.
        enddo
      endif
!
      if(soil_sa_wet_tot.gt.0.)then
        do k=1,nsoil
          soil_sa_wet(k)=soil_sa_wet(k)/soil_sa_wet_tot
        enddo
      else
        do k=1,nsoil
          soil_sa_wet(k)=0.
        enddo
      endif
!
!-----------------------------------------------------------------------
!
      do k=1,nsoil
        if(soil_sa_wet(k).gt.0.) then
          soil_sa_ratio(k)=soil_sa(k)/soil_sa_wet(k)
        else
          soil_sa_ratio(k)=0.
        endif
      enddo
!
      do k=1,nsoil
        if(soil_mf_wet(k).gt.0.) then
          soil_mf_ratio(k)=soil_mf(k)/soil_mf_wet(k)
        else
          soil_mf_ratio(k)=0.
        endif
      enddo
!
!-----------------------------------------------------------------------
!     VOLUMETRIC TO GRAVIMETRIC SOIL MOISTURE AFTER ZENDER ET AL 2003
!-----------------------------------------------------------------------
!
      vsmc_sat=0.489-1.26*(soil_mf_wet(3)+soil_mf_wet(4))  ! Volumetric soil water content at saturation (Zender et al. 2003)
      rho_bulk=1600.*(1.-vsmc_sat)                         ! bulk density of dry sandy soil (1100 for clayey soil)
!
!-----------------------------------------------------------------------
!     DUST EMISSION FLUX PARAMETERIZATION STARTS HERE
!     FIRST RESET THE ARRAYS
!-----------------------------------------------------------------------
!
      do t=1,temp_time
        hflux_tot(t)=0.
        vflux_tot(t)=0.
        do k=1,nsoil
          hflux_soil(t,k)=0.
          vflux_soil(t,k)=0.
        enddo
      enddo
!
!-----------------------------------------------------------------------

      do t=1,temp_time
!
!-----------------------------------------------------------------------
!
        z0temp=0.
        drag_corr=0.
        do k=1,nsoil
          hflux(k)=0.
        enddo
!
!-----------------------------------------------------------------------
!     DRAG PARTITION CORRECTION AFTER SHAO 2004
!     Z0DUST - aeolian (meteo) roughness length
!-----------------------------------------------------------------------
!
        z0temp=1.0*z0dust(t)
!
        av=0.0                         ! vegetation fraction assumed zero for our purposes
        lambdav=-0.35*log(1-av)        ! C_lambda for stubble roughness according Darmenova et al. 2010
        lambdab=z0temp*2.2/(1-av)      ! eta*f = z0temp*2.2 according Table 2 in Darmenova et al. 2010
!
        drag_corr=1/(sqrt(1.0-(1.45*0.16*lambdav))                      &
     &              *sqrt(1.0+(0.16*202.*lambdav))                      &
     &              *sqrt(1.0-(1.0 *0.5 *lambdab))                      &
     &              *sqrt(1.0+(0.5 *90.0*lambdab)))
!
        if(drag_corr.lt.0.0001) drag_corr=0.0001
!
!-----------------------------------------------------------------------
!
        do k=1,nsoil
!
!-----------------------------------------------------------------------
!     SOIL MOISTURE CORRECTION AFTER FECAN 1999
!-----------------------------------------------------------------------
!
          if(vsmc_temp(t).eq.1.) gsmc=1.
          if(vsmc_temp(t).lt.1.) gsmc=vsmc_temp(t)*1000./rho_bulk    ! Gravimetric SMC in kg/kg and volumetric in m3/m3
          gsmc_frac=gsmc*100.*1.0
          if(gsmc_frac.gt.wprim.and.gsmc_frac.lt.100.) then
            ustarthr(k)=ustardry(k)*sqrt(1.+1.21                        &
     &                 *(gsmc_frac-wprim)**0.68)
          else
            ustarthr(k)=ustardry(k)
          endif
          if(vsmc_temp(t).eq.1.) ustarthr(k)=20.0
!
          ustarthr(k)=ustarthr(k)/drag_corr
!
!-----------------------------------------------------------------------
!     HORIZONTAL FLUX AFTER SHAO 2004
!     FACTOR AFTER Kawamura 1964 (1.8...3.1)
!-----------------------------------------------------------------------
!
          if(ustar(t).ge.ustarthr(k)) then
            hflux(k)=2.45*(air_dens/g)*(ustar(t)**3)                    &
     &              *(1-((ustarthr(k)**2)/(ustar(t)**2)))*soil_sa(k)
          endif
          hflux_tot(t)=hflux_tot(t)+hflux(k)
          hflux_soil(t,k)=hflux(k)
!
!----------------------------------------------------------------------
!    VERTICAL TO HORIZONTAL DUST MASS FLUX RATIO alpha after Shao 2004
!    AS VFLUX EMITS DISINTEGRATED PARTICLES, SOIL_MF_WET IS USED
!----------------------------------------------------------------------
!
          gamm=1.0*exp(-(ustar(t)-ustarthr(k))**3)
          sigmm=12.0*(ustar(t)/ustp)**2*(1.0+(14.0*(ustar(t)/ustp)))
          alpha_soil(k)=5.E-5*soil_mf_wet(k)*((1-gamm)                  &
     &                 +(gamm*soil_mf_ratio(k)))*(1+sigmm)
!
!-----------------------------------------------------------------------
!     VERTICAL FLUX AFTER SHAO 2004
!     CONVERSION FROM kg/m3 TO mg/m3
!-----------------------------------------------------------------------
!
          vflux_soil(t,k)=alpha_soil(k)*hflux_soil(t,k)*g/ustar(t)**2   &
     &                   *1.E6
          vflux_tot(t)=vflux_tot(t)+vflux_soil(t,k)
          if(vsmc_temp(t).eq.1.0) vflux_tot(t)=0.0
!
!-----------------------------------------------------------------------
!
        enddo
!
!-----------------------------------------------------------------------
!
      enddo
!
!-----------------------------------------------------------------------
      end subroutine shao
!-----------------------------------------------------------------------
!
